<?php

namespace Ecommerce\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class AtualizarFreteController extends \Teknisa\Libs\Controller\CRUD {

   protected $AtualizarFreteService;
    
    
    public function __construct($crudService, $environment, $AtualizarFreteService){
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->AtualizarFreteService = $AtualizarFreteService;
    }
    
    public function atualizarFrete(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $params = array(
                ":P_VRFRETEFORNEPEDCOL" => $row["VRFRETEFORNEPEDCOL"],
                ":P_CDFILIAL"           => $row["CDFILIAL"],
                ":P_NRPEDIDOCOL"        => $row["NRPEDIDOCOL"],
                ":P_CDFORNECED"         => $row["CDFORNECED"]
            );
            
            
            $this->AtualizarFreteService->updateValorFrete($params);
            
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    public function checarFornecedor(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $params = array(
                ":P_CDFORNECED" => $row["CDFORNECED"]
            );
            
            $retorno = $this->AtualizarFreteService->checarFornecedor($params);
            $response->addDataSet(new DataSet("FORNECEDOR", $retorno));
            
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), 1));
        }
        
    }
}
